#ifndef CORE_FRUSTUM_HPP
#define CORE_FRUSTUM_HPP

#include "core/Array.hpp"
#include "core/Matrix.hpp"
#include "core/Plane.hpp"

namespace Core {
    class Frustum final {
        Matrix projection;
        Array<Plane, 6> planes;
        float tan;
        float near;
        float far;

    public:
        Frustum(float fieldOfView, float nearClip, float farClip);
        const Matrix& updateProjection(const IntVector2& size);
        void updatePlanes(
            const Vector3& pos, const Vector3& right, const Vector3& up,
            const Vector3& front, const IntVector2& size);

        bool isInside(const Vector3& pos) const;
        bool isInside(const Vector3& pos, float radius) const;
    };
}

#endif
