#ifndef CORE_VIEW_HPP
#define CORE_VIEW_HPP

#include "core/Matrix.hpp"

namespace Core {
    class View {
        Matrix view{};
        Vector3 back{};
        Vector3 down{};
        Vector3 front{};
        Vector3 left{};
        Vector3 right{};
        Vector3 up{};

    public:
        void updateDirections(float lengthAngle, float widthAngle);
        void updateDirections(const Quaternion& q);
        const Matrix& updateMatrix(const Vector3& pos);
        const Vector3& getBack() const;
        const Vector3& getDown() const;
        const Vector3& getFront() const;
        const Vector3& getLeft() const;
        const Vector3& getRight() const;
        const Vector3& getUp() const;
    };
}

#endif
